# SiB App

SiB App is the magic tool that allows the Happy Dev network to thrive in a decentralized way.

## Getting Started

These instructions will get you a copy of the project up and running on your local machine for development and testing purposes. See deployment for notes on how to deploy the project on a live system.

### Prerequisites

To install SiB App, you'll need to have:

- Python3 & Pip
- NodeJS & NPM
- A Prosody Server
- (Optional) A SMTP Server

### Installing

[Install a server and a client application](https://git.happy-dev.fr/startinblox/devops/doc/wikis/deploy_a_sib_application)

Or build the docker images and run it:
```
$ docker build -t sibapp docker/
$ docker run --rm -p 127.0.0.1:8000:8000 -it sibapp
```

## FIXME

Create a Client ID for Prosody & Client

- Go to `localhost:8000/admin/`
- Login with previously created account.
    - If needed you can create another admin account with `./manage.py createsuperadmin`
- Add a `Clients` on `OpenID Connect Provider` section
    - Name it as you wish
    - `Client type`: `Public`
    - `Response types`: `id_token token (Implicit Flow)`
    - `Redirect URIs`:
        ```
        http://localhost:3000
        http://127.0.0.1:3000
        http://0.0.0.0:3000
        http://localhost:8000
        https://myserver.com
        ```
- Keep the `6-digits` newly create `Client ID` somewhere

Configure `config.json`:

On the newly created `./src/config.json` change the `dev` configuration like this:
```
  "dev": {
    "sdn": "http://api.myserver.com", # Or localhost:8000
    "cdn": "https://cdn.happy-dev.fr",
    "xmpp": "https://prosody.myserver.com/http-bind/",
    "client_id": "000000" # <- Here goes your previously created Client ID
  },
```

## Built With

* [Sib-Core](https://git.happy-dev.fr/startinblox/framework/sib-core/) - An awesome new framework!

### Architecture

Some general schema of the existing StartinBlox applications architecture can be found [here](https://docs.google.com/presentation/d/1iCRGaJpFvZjhjIUnpsn6lRTJJ31ES6n94BNkJygzUwM/edit?usp=sharing).

<!---
## Contributing

We may add a `CONTRIBUTING.md`

## License

We may add a `LICENSE.md`

## Acknowledgments

* Maybe some thanks too
* Inspiration
* etc
--->
